;
; Test program for simulation of 16-bit soft CPU
;
	LDL	R0,3
SPIN:	DEC	R0	;loop 3 times
	JNZ	SPIN
	LDL	R0,3
	MARK
	DEC	R0	;loop 3 times
	LNZ
	LDL	R0,3
	REP	3
	DEC	R0	;loop 3 times
	LDL	R0,$34	;initialize LSB R0
	LDH	R0,$12	;initialize MSB R0
	LDL	R1,1	;sign extend 8-bit value
	LOAD	R2,2 	;load 16-bit value
	LOAD	R13,255
	LOAD	R14,+255
	LOAD	R15,-255
	MOV	R3,R0	;copy to R3
MAIN:
	OUT	R3,$30	;output R3
	IN	R3,$30	;modify R3
	OUT	R3,$30	;output R3
	INC	R0	;increment counter
	DEC	R0	;decrement counter
	CLR	R0	;clear R0 and R3
	CLR	R3
	SUB	R0,R1	;decrement by 201h
	SUBC	R3,R2
	ADD	R0,R1	;increment by 201h
	ADDC	R3,R2
	CSUB	R0,R1	;decrement by 1
	CADD	R0,R1	;increment by 1
	DECB	R0	;decrement by 1
	INCB	R0	;increment by 1
	CLR	R0	;clear R0
	OR	R0,R1	;test logical operations
	XOR	R0,R1	;test logical operations
	AND	R0,R2	;test logical operations
	MOV	R0,R2	;test logical operations
	CLR	R0	;clear R0
	SET	R0,0	;test bit manipulation
	RST	R0,0	;test bit manipulation
	INV	R0,0	;test bit manipulation
	SET	R0,15	;test bit manipulation
	RST	R0,15	;test bit manipulation
	INV	R0,15	;test bit manipulation
	CALL	SUBR	;
	JMP	MAIN	;loop forever
SUBR:
	ROR	R13	;rotate without link bit
	ROL	R13
	RRC	R13	;rotate with link bit
	RLC	R13
	LSR	R13	;shift and insert 0
	LSL	R13	;shift back and lose LSB
	REV	R13,R13	;reverse order
	LSL	R13	;and shift MS one bit to sign bit
	ASR	R13	;shift and replicate sign bit
	SWAP	R13,R13	;reverse bytes and restore original value
	MLL	R3,R1	;set LSB
	MLH	R3,R2	;set MSB
	MLLS	R3,R1	;retreive LSB
	MHLS	R3,R2	;retreive MSB
	MUL	R1,R2	;initialize accumulator
	MAC	R2,R1	;and add another product
	LPL	R0	;retreive result
	LPH	R3
	RD	R0,R1	;test memory access
	RD	R3,R2
	WR	R0,R2	;swap contents
	WR	R3,R1
	XCHG	R0,R1	;swap again
	XCHG	R3,R2
	RET
