//
//		addsubincdec16a.v - 16-bit adder/subtracter/incrementer/decrementer
//
//					(C) Copyright 2004-2008 John B. Stephensen
//
// This Verilog source file and all its derivatives are licensed only for
// personal non-profit educational use in the Amateur Radio Service and
// the license is not transferrable. The information is provided as-is for
// experimental purposes and the author does not warranty its freedom
// from defects or its suitability for any specific application.
//
//	OP	Desc.
// 00	SUB
//	01	ADD
//	10	INC
//	11	DEC
//
// 8 slices used. Tsu = 4.801 ns and Tcq = 4.283 ns.
//
module addsubincdec16a(
    input [1:0] OP,
    input [15:0] A,
    input [15:0] B,
    input CI,
    output CO,
    output [15:0] Y
    );
// internal signals
wire [14:0] c;	// carry propogation
// use 16 one-bit adders
addsubincdec1a a15 (.OP(OP), .A(A[15]), .B(B[15]), .CI(c[14]), .CO(CO), .Y(Y[15]));
addsubincdec1a a14 (.OP(OP), .A(A[14]), .B(B[14]), .CI(c[13]), .CO(c[14]), .Y(Y[14]));
addsubincdec1a a13 (.OP(OP), .A(A[13]), .B(B[13]), .CI(c[12]), .CO(c[13]), .Y(Y[13]));
addsubincdec1a a12 (.OP(OP), .A(A[12]), .B(B[12]), .CI(c[11]), .CO(c[12]), .Y(Y[12]));
addsubincdec1a a11 (.OP(OP), .A(A[11]), .B(B[11]), .CI(c[10]), .CO(c[11]), .Y(Y[11]));
addsubincdec1a a10 (.OP(OP), .A(A[10]), .B(B[10]), .CI(c[9]), .CO(c[10]), .Y(Y[10]));
addsubincdec1a a9 (.OP(OP), .A(A[9]), .B(B[9]), .CI(c[8]), .CO(c[9]), .Y(Y[9]));
addsubincdec1a a8 (.OP(OP), .A(A[8]), .B(B[8]), .CI(c[7]), .CO(c[8]), .Y(Y[8]));
addsubincdec1a a7 (.OP(OP), .A(A[7]), .B(B[7]), .CI(c[6]), .CO(c[7]), .Y(Y[7]));
addsubincdec1a a6 (.OP(OP), .A(A[6]), .B(B[6]), .CI(c[5]), .CO(c[6]), .Y(Y[6]));
addsubincdec1a a5 (.OP(OP), .A(A[5]), .B(B[5]), .CI(c[4]), .CO(c[5]), .Y(Y[5]));
addsubincdec1a a4 (.OP(OP), .A(A[4]), .B(B[4]), .CI(c[3]), .CO(c[4]), .Y(Y[4]));
addsubincdec1a a3 (.OP(OP), .A(A[3]), .B(B[3]), .CI(c[2]), .CO(c[3]), .Y(Y[3]));
addsubincdec1a a2 (.OP(OP), .A(A[2]), .B(B[2]), .CI(c[1]), .CO(c[2]), .Y(Y[2]));
addsubincdec1a a1 (.OP(OP), .A(A[1]), .B(B[1]), .CI(c[0]), .CO(c[1]), .Y(Y[1]));
addsubincdec1a a0 (.OP(OP), .A(A[0]), .B(B[0]), .CI(CI), .CO(c[0]), .Y(Y[0]));
endmodule
