//
//		addsubincdec8a.v - 8-bit adder/subtracter/incrementer/decrementer
//
//					(C) Copyright 2004-2008 John B. Stephensen
//
// This Verilog source file and all its derivatives are licensed only for
// personal non-profit educational use in the Amateur Radio Service and
// the license is not transferrable. The information is provided as-is for
// experimental purposes and the author does not warranty its freedom
// from defects or its suitability for any specific application.
//
//	OP	Desc.
// 00	SUB
//	01	ADD
//	10	INC
//	11	DEC
//
// 8 slices used.
//
module addsubincdec8a(
    input [1:0] OP,
    input [7:0] A,
    input [7:0] B,
    input CI,
    output CO,
    output [7:0] Y
    );
// internal signals
wire [6:0] c;	// carry propogation
// use 8 one-bit adders
addsubincdec1a a7 (.OP(OP), .A(A[7]), .B(B[7]), .CI(c[6]), .CO(CO), .Y(Y[7]));
addsubincdec1a a6 (.OP(OP), .A(A[6]), .B(B[6]), .CI(c[5]), .CO(c[6]), .Y(Y[6]));
addsubincdec1a a5 (.OP(OP), .A(A[5]), .B(B[5]), .CI(c[4]), .CO(c[5]), .Y(Y[5]));
addsubincdec1a a4 (.OP(OP), .A(A[4]), .B(B[4]), .CI(c[3]), .CO(c[4]), .Y(Y[4]));
addsubincdec1a a3 (.OP(OP), .A(A[3]), .B(B[3]), .CI(c[2]), .CO(c[3]), .Y(Y[3]));
addsubincdec1a a2 (.OP(OP), .A(A[2]), .B(B[2]), .CI(c[1]), .CO(c[2]), .Y(Y[2]));
addsubincdec1a a1 (.OP(OP), .A(A[1]), .B(B[1]), .CI(c[0]), .CO(c[1]), .Y(Y[1]));
addsubincdec1a a0 (.OP(OP), .A(A[0]), .B(B[0]), .CI(CI), .CO(c[0]), .Y(Y[0]));
endmodule
